#!/usr/local/bin/perl 

use Carp 'croak'; 
use Socket6; 
use IO::Socket::Multicast6;

my $addr = "FF02:0:0:0:0:0:0:6061";
my $port = 5000;

my $s = IO::Socket::Multicast6->new (LocalPort => $port);
croak("Could not create a socket") if (not defined $s);

# this is not quite portable. em1 will have to replaced by appropriate
# interface name
$s->mcast_add($addr, 'em1'); 

my ($pkt, $num) = (); 
while (1) { 
  $peer= $s->recv($pkt, 4096); 
  my ($port, $host) = unpack_sockaddr_in6 ($peer); 
  $host = inet_ntop(AF_INET6, $host); 
  print "($port, $host): got pkt = \"$pkt\"\n";
}
