#! /usr/local/bin/perl 

use Carp 'croak'; 
use Socket6; 
use IO::Socket::Multicast6;

my $addr = "FF02:0:0:0:0:0:0:6061";
my $port = 5000;

my $s = IO::Socket::Multicast6->new (
             LocalPort => 5000 ,
	     Proto => 'udp' 
);

croak("Could not create a socket") if (not defined $s);

# initiate a join
$s->mcast_add($addr, 'xl0'); 

# set the destination multicast address for the transmission
my $dest = pack_sockaddr_in6($port, inet_pton(AF_INET6, $addr));
$s->mcast_dest($dest); 

my $msg = "TESTTESTTEST"; 
while (1) { 
  my $sent = $s->mcast_send($msg);
  if ($sent != length $msg){
    croak ("Could not send the message"); 
  }
} continue { 
  print "sent one\n";
  sleep (1); 
}
